.nolist	; creates a 7.0k editor that has most if not all features needed for building assembler apps
useGMF=1
useMb=0
ife useMb
	include \masm32\include\masm32rt.inc
else
	include \masm32\MasmBasic\MasmBasic.inc		; see xx_endp - [url=http://www.masm32.com/board/index.php?topic=12460]download[/url]
endif

WinMain	PROTO:DWORD,:DWORD,:DWORD,:DWORD
SetSelFormat	PROTO:DWORD,:DWORD
MyFiles	PROTO:DWORD

AppX	= 35	; see if Ishelp, ecx*9!!
AppY	= 60
AppWidth	= 760
ButMargin	= 3
ButWidth	= 54
ButHeight	= 24

m2m MACRO M1, M2
  pushd M2
  pop dword ptr M1
ENDM

movi MACRO M1, M2
LOCAL oa, num
  num = M2		;; get rid of sizeof xxx syntax
  oa = (opattr num) and 127
  if oa ne 36
	echo <M2> is not an immediate
	.err
  endif
  if num le 127
	pushd M2
	pop dword ptr M1
  else
	mov M1, M2
  endif
ENDM

crtbuf MACRO var, BufLen
LOCAL lbl
.data?
align 4			; first data item, so it is already aligned
  lbl LABEL byte
  ORG $+BufLen-1
  db ?
  .data
	var dd lbl			;; define it in the data section
  .code
ENDM

SizeNormal	= 240	; in twips
SizeLarge	= 280
SizeXXL	= 360
Font_RED	= 0000FFh
Font_BLUE	= 0FF0000h
BgYellow	= 0AAFFFFh
SelXxlSize	= 4096000

sm	equ invoke SendMessage, ; for faster typing ;-)
signed	equ sdword ptr 
IdButton0	= 100	; startpoint of buttons
IdMenuHelp	= 100
IdMenuOpen	= 101	; ID menu item New
IdMenuSave	= 102	; ID menu item Save
IdMenuSaveAs	= 103	; ID menu item Save
IdMenuAssRun	= 104
IdMenuBold	= 105
IdMenuLarge	= 106
IdMenuEmRed	= 107
IdMenuBlue	= 108
IdMenuHilite	= 109
IdMenuFind	= 110
IdMenuReplace	= 111
idPrint	= 112
IdMenuFindNext	= 113
IdEscape	= 114	; last item
IdEdit	= 120
IdStatic	= 121
IdButtonMax	= 14	; number of buttons+1; see ButtonTable, ButtonJumps

.data	; last update 4 May 2012
dummy db 48 dup(0)	; for testing how many bytes are needed to bite into the next 512 bytes...
MyAccels	ACCEL <FCONTROL or FVIRTKEY, VK_O, IdMenuOpen>
	ACCEL <FCONTROL or FVIRTKEY, VK_S, IdMenuSave>
	ACCEL <FVIRTKEY, VK_F1, IdMenuHelp>
	ACCEL <FVIRTKEY, VK_F3, IdMenuFindNext>
	ACCEL <FVIRTKEY or FSHIFT, VK_F3, IdMenuFindNext>
	ACCEL <FCONTROL or FVIRTKEY, VK_F, IdMenuFind>
	ACCEL <FCONTROL or FVIRTKEY, VK_R, IdMenuReplace>
	ACCEL <FVIRTKEY, VK_F6, IdMenuAssRun>
	ACCEL <FCONTROL or FVIRTKEY, VK_B, IdMenuBold>
	ACCEL <FCONTROL or FVIRTKEY, VK_L, IdMenuLarge>
	ACCEL <FCONTROL or FVIRTKEY or FSHIFT, VK_L, IdMenuLarge>
	ACCEL <FCONTROL or FVIRTKEY, VK_E, IdMenuEmRed>
	ACCEL <FCONTROL or FVIRTKEY or FSHIFT, VK_B, IdMenuBlue>
	ACCEL <FCONTROL or FVIRTKEY, VK_H, IdMenuHilite>
	ACCEL <FCONTROL or FVIRTKEY, VK_P, idPrint>
LastAccel	ACCEL <FVIRTKEY, VK_ESCAPE, IdEscape>	; quit
ButtonJumps	dd proButton0, proButton1, proButton2, proButton3, AssRun, proButton5, proButton6
	dd proButton7, proButton8, proButton9, FindOnly, FindReplace, PrintRTF, FindNext, proButtonEsc, 0
txtButton0	db "Help", 0
txtButton1	db "Open", 0
txtButton2	db "Save", 0
txtButton3	db "Save as", 0
txtButton4	db "Build", 0
txtButton5	db "Bold", 0
txtButton6	db "Large", 0
txtButton7	db "Red", 0
txtButton8	db "Blue", 0
txtButton9	db "Hilite", 0
txtButton10	db "Find", 0
txtButton11	db "Replace", 0
txtButton12	db "Print", 0, 0	; double 0 means eof table

ClassAppWin	db "TinyRtf", 0
ClassButton	db "button", 0
ClassStatic	db "static", 0
;  Office 12 needs C:\Program Files\Common Files\Microsoft Shared\OFFICE12\MSPTLS.DLL in the RichMasm folder, and is slower!!
; The case of %ProgramFiles% or %commonprogramfiles% must be exactly as shown because the string comparison is case-sensitive.
; For example, if the string begins with %CommonProgramFiles% instead of %commonprogramfiles%, it is not replaced - [url=http://msdn.microsoft.com/en-us/library/aa384232%28v=vs.85%29.aspx]MSDN[/url]
LibNameOffice	db "%commonprogramfiles%\Microsoft Shared\OFFICE11\"	; no zero delimiter here, fall thru
LibName	db "RichEd20.dll", 0
ReVersion	db "RichEdit20A", 0

MyFont	db "Arial", 0
AppName	db "Tiny RTF Editor: ", 0
txFilter	db "Rich Text files", 0, "*.rtf", 0
	db "Plain Asm", 0, "*.asm", 0, 0
txBatch	db "TinyTmp.bat ", 0
txBatchDef	db "TinyDef.bat "	;, 0 keep with next ;-)
txStatic	db 0	; we are stingy, no "Welcome" here

.data?
StreamMode	dd ?
IsHelp	dd ?
;ChkEsp	dd ?
SaveAs	dd ?
;lpWritten	dd ?
hFR	dd ?
frs	FINDREPLACE <>
WM_FindReplace	dd ?	; FindR
BufFind	dd 50 dup (?)
BufRepl	dd 50 dup (?)
hInstance	HINSTANCE ?
hStatic	HWND ?
hEdit	HWND ?
hMenu	HANDLE ?
hM1	HANDLE ?
hM2	HANDLE ?
hButFnt	HANDLE ?
hAccT	HANDLE ?
GmfBuffer	db MAX_PATH dup (?)
ComLineBuffer	db MAX_PATH dup (?)
WinTitleBuffer	db MAX_PATH+40 dup (?)
jct	dd ?
LineBuf	dd ?, ?
dwtoaBuf	db 80 dup (?)
hWin 	equ frs.hwndOwner

.code
	if useMb
 xx_s:	; see xx_endp
	endif
if useGMF
	OPTION PROLOGUE:NONE
	OPTION EPILOGUE:NONE
	GMF proc buffer
		pop eax	; get ret addr
		xchg eax, [esp]	; exchange with ptr buffer
		invoke GetModuleFileName, 0, eax, MAX_PATH	; returns # of chars
		retn	; retn zero because we popped the arg
	GMF endp
endif
start:
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef
	if useMb
		CodeSize xx	; with MasmBasic only
	endif
	crtbuf	SelXXL$,	SelXxlSize	; fat buffer for GetCurSel & Sel (409600)
	mov hInstance, rv(GetModuleHandle, NULL)
	mov esi, offset ComLineBuffer
	invoke GetCL, 1, esi
	.if eax!=1
		invoke lstrcpy, esi, chr$("TinyDemo.rtf")
	.endif
	.Repeat
		lodsb
	.Until !al
	.if dword ptr [esi-9]=="pleH"	; "Help"
		inc IsHelp
	.endif
	invoke WinMain, hInstance, 0, 0, SW_SHOWDEFAULT
	; MsgBox 0, "Bye", offset AppName, MB_OK	; uncomment to test if your code exits properly
	invoke ExitProcess, eax

WinMain proc hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
LOCAL wc:WNDCLASSEX
LOCAL msg:MSG
	call ClearLocVars					; set all local variables to zero
	push ebx
	movi wc.cbSize, SIZEOF WNDCLASSEX
	movi wc.style, CS_HREDRAW or CS_VREDRAW
	mov wc.lpfnWndProc, offset WndProc	; m2m longer
;	 mov wc.cbClsExtra, NULL			; already zeroed
;	 mov wc.cbWndExtra, NULL			; by ClearLocVars
	m2m wc.hInstance, hInst
	movi wc.hbrBackground, COLOR_WINDOW			; ->GetSysColor
	m2m wc.lpszClassName, offset ClassAppWin
	mov wc.hIcon, rv(LoadIcon, hInst, IDI_APPLICATION)
	mov wc.hIconSm, eax								; reuse eax as returned by rv
	mov wc.hCursor, rv(LoadCursor, NULL, IDC_ARROW)
	invoke RegisterClassEx, addr wc
	push rv(GetSystemMetrics, SM_CYSCREEN)
	; call InitCommonControls not needed
	movi ecx, AppX				; lt 128, m2m shorter
	movi edx, AppWidth			; ge 128, mov shorter
	.if IsHelp
		lea ecx, [ecx+8*ecx+127]
		sub edx, 127
	.endif
	pop eax		; screen height
	sub eax, 2*AppY
	xor ebx, ebx
	invoke CreateWindowEx, ebx,
		wc.lpszClassName, ebx,
		WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN or WS_VISIBLE,
		ecx, AppY, edx, eax,
		ebx, ebx, hInst, ebx				; sets hWin in WM_CREATE
	lea ebx, msg
	.Repeat
		invoke GetMessage, ebx, 0, 0, 0
		.break .if !eax
		invoke IsDialogMessage, hFR, ebx	; if active, hfr <> 0
		.if !eax
			invoke TranslateAccelerator, hWin, hAccT, ebx
			.if !eax
				invoke TranslateMessage, ebx
				invoke DispatchMessage, ebx
			.endif
		.endif
	.Until 0
	pop ebx
	mov eax, msg.wParam	; m2m longer
	ret
WinMain endp

WndProc proc uses edi ebx hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
LOCAL ButTop, rc:RECT,  buffer[111]:BYTE	; 111 + 16 = 127
	SWITCH uMsg
	CASE WM_CREATE
		; -------------------- create keyboard shortcuts ----------------------------
		; no m2m hWin, hWnd	; a global copy for MsgBox etc
;		int 3
		frsx equ [edi.FINDREPLACE]
		mov edi, offset frs
		movi frsx.lStructSize, sizeof FINDREPLACE
		m2m frsx.hwndOwner, hWnd
		movi frsx.Flags, FR_DOWN			; enter once, let user keep settings
		m2m frsx.lpstrReplaceWith, offset BufRepl	; local??
		m2m frsx.lpstrFindWhat, offset BufFind
		movi frsx.wFindWhatLen, sizeof BufFind
		movi frsx.wReplaceWithLen,  sizeof BufRepl
		; we need a dirty trick against Masm 9.0: bye bye to invoke, push by hand...!
		push dword ptr ((LastAccel-MyAccels)/(SIZEOF ACCEL)+1)
		push offset MyAccels
		call	CreateAcceleratorTable
		mov hAccT, eax
		; -------------------- create controls: buttons, edit window, static ---------- 
		invoke GetStockObject, ANSI_VAR_FONT	; get a cute little font for the controls
		mov hButFnt, eax
		lea edi, buffer
		invoke ExpandEnvironmentStrings, offset LibNameOffice, edi, 110
		or ebx, -1	; we need two attempts
		.Repeat
			invoke LoadLibrary, edi	; first round: RichEd20.dll, Office 11/12 version
;			deb 4, "Lib", eax, $edi
			.Break .if eax
			mov edi, offset LibName	; second round: RichEd20.dll
			inc ebx
		.Until !Zero?	; after round 1, ebx is zero
		MyExStyle = WS_EX_CLIENTEDGE
		MyStyle = WS_CHILD or ES_MULTILINE or WS_VSCROLL or WS_CLIPSIBLINGS or WS_VISIBLE
		xor ebx, ebx
		invoke CreateWindowEx, MyExStyle, offset ReVersion, ebx,
		    MyStyle,
		    ebx, ebx, ebx, ebx, hWnd, IdEdit, hInstance, ebx
		mov hEdit, eax						; we have created a RichEdit control
		xchg eax, ebx						; aka hEdit
		movi eax, ENM_SELCHANGE or ENM_CHANGE
		sm ebx, EM_SETEVENTMASK, 0, eax	; send notifications for SELCHANGE
		sm ebx, EM_EXLIMITTEXT, 0, -1 	; text limit (default 64K)
		sm ebx, EM_SETMARGINS, EC_LEFTMARGIN or EC_RIGHTMARGIN, 4
		.if IsHelp==0
			call CreateButtons
		.endif
		mov WM_FindReplace, rv(RegisterWindowMessage, chr$("commdlg_FindReplace"))
		sm ebx, EM_SETBKGNDCOLOR, 0, 0F8FFEEh	; BGR
		invoke MyFiles, offset ComLineBuffer

	CASE WM_COMMAND					; react here to menus and controls
		movzx ecx, word ptr wParam+2			; notification code in hiword of wParam
		movzx eax, word ptr wParam			; the Ids are in the loword of wParam
		sub eax, IdButton0
		.if !Sign?
			.if eax<=IdButtonMax && (ecx==BN_CLICKED || ecx==1)	; ecx=1: Accel
				call [ButtonJumps+4*eax]
			.endif
		.endif

	CASE WM_NOTIFY
		mov edx, lParam					; Pointer to NOTIFY structure
		mov eax, [edx.NMHDR.code]		; message+8 = code
		.if eax==EN_SELCHANGE
			mov edi, offset dwtoaBuf-5
			mov eax, "eniL"						; Line
			stosd
			mov al, " "
			stosb
			invoke SendMessage, hEdit, EM_EXLINEFROMCHAR, 0, -1
			invoke dwtoa, eax, edi
			sub edi, 5
			invoke SendMessage, hStatic, WM_SETTEXT, 0, edi
		.endif

	CASE WM_FindReplace
		mov eax, lParam
		call DoFR

	CASE WM_SIZE			; resize controls
		invoke GetClientRect, hWnd, addr rc
		mov eax, rc.right
		sub eax, ButWidth+3*ButMargin	; editbox = window width minus button width
		mov ecx, rc.bottom
		sub ecx, 2*ButMargin
		movi edx, ButWidth+2*ButMargin
		.if IsHelp
			sub edx, ButWidth+ButMargin
			add eax, ButWidth+1
		.endif
		invoke MoveWindow, hEdit, edx, ButMargin, eax, ecx, 1

 	CASE WM_ACTIVATE
		movzx eax, word ptr wParam	; the fActive flag
		sub eax, WA_INACTIVE
		.if !Zero?
			invoke SetTimer, hWnd, 77, 100, 0
		.endif
 
	CASE WM_TIMER
		invoke KillTimer, hWnd, 77
 		invoke SetFocus, hEdit

 	 CASE WM_CLOSE
		call ChkMods
		.if eax
			xor eax, eax
			jmp bye		; return 0
		.endif

 	CASE WM_DESTROY
		invoke PostQuitMessage, NULL
	ENDSW
	invoke DefWindowProc, hWnd, uMsg, wParam, lParam
bye:	ret	; WndProc

CreateButtons:
  ; push edi
  push esi
  push ebx
  if 1	; 54 bytes shorter then ButtonTable solution
	mov esi, offset txtButton0		; with offset, mov is shorter than m2m
	movi ebx, IdButton0
	movi ButTop, ButMargin+1		; left margin = top margin (m2m 8 bytes, mov 10)
	.Repeat
		invoke CreateWindowEx, NULL, offset ClassButton, esi,	; eax=address txButtonN
		  WS_CHILD or WS_VISIBLE or BS_PUSHBUTTON, ButMargin, ButTop, ButWidth, ButHeight,
		  hWin, ebx, hInstance, NULL
		sm eax, WM_SETFONT, hButFnt, 1	; give it the small font
		add ButTop, ButHeight+ButMargin
		inc ebx
		.Repeat
			lodsb
		.Until !al
	.Until byte ptr [esi]==al
  else
	mov esi, offset ButtonTable		; with offset, mov is shorter than m2m
	movi ebx, IdButton0
	movi ButTop, ButMargin+1		; left margin = top margin (m2m 8 bytes, mov 10)
	.Repeat
		lodsd
		.break .if !eax
		invoke CreateWindowEx, NULL, offset ClassButton, eax,	; eax=address txButtonN
		  WS_CHILD or WS_VISIBLE or BS_PUSHBUTTON, ButMargin, ButTop, ButWidth, ButHeight,
		  hWin, ebx, hInstance, NULL
		sm eax, WM_SETFONT, hButFnt, 1	; give it the small font
		add ButTop, ButHeight+ButMargin
		inc ebx
	.Until 0
  endif
  add ButTop, 3
  invoke CreateWindowEx, NULL, addr ClassStatic, addr txStatic,
    WS_CHILD or WS_VISIBLE or ES_RIGHT, ButMargin, ButTop, ButWidth-3, ButHeight*9,
    hWin, IdStatic, hInstance, NULL
  mov hStatic, eax						; static window under buttons created
  sm eax, WM_SETFONT, hButFnt, 1	; give it the small font
  pop ebx
  pop esi
  ; pop edi
  retn
WndProc endp

ChkMods proc
  sm hEdit, EM_GETMODIFY, 0, 0
  .if eax
	MsgBox 0, chr$("You made changes.", 13, "Save now?"), addr AppName, MB_YESNOCANCEL
	sub eax, IDYES
	.if Zero?
		invoke MyFiles, eax	; save current
		xor eax, eax		; flag exit
	.else
		sub eax, IDNO-IDYES		; ret zero for IDNO
	.endif
  .endif
  ret
ChkMods endp

proButton0 proc 					; Help
  cmp IsHelp, 0
  jne short proButtonEsc
  push edi
  mov edi, offset GmfBuffer
  push SW_RESTORE
  push edi
  invoke GMF, edi
  add edi, eax
  mov al, 32
  stosb
  invoke GMF, edi		; GetModuleFileName
  lea eax, [edi+eax-7]
  invoke lstrcpy, eax, chr$("Help.rtf")
  call WinExec		; invoke WinExec, edi, SW_RESTORE
  pop edi
  ret
proButton0 endp

proButtonEsc proc
  sm hWin, WM_CLOSE, 0, 0			; Escape: exit without asking (unless your text was modified)
  ret
proButtonEsc endp

proButton1 proc ; Open
  call ChkMods
  test eax, eax
  je pbIncEax		; invoke MyFiles, 1
  ret
proButton1 endp

proButton2 proc ; Save
  or eax, -1
pbIncEax::
  inc eax
  invoke MyFiles, eax
  ret
proButton2 endp

proButton3 proc ; Save as
  or SaveAs, -1	; flag
  jmp short proButton2
;  invoke MyFiles, 0
;  ret
proButton3 endp

proButton5 proc ; Bold
  push CFM_BOLD
  push CFE_BOLD
  jmp CallSSF
proButton5 endp

proButton6 proc ; Large
  invoke GetKeyState, VK_SHIFT		; GetKeyState returns a WORD (?)
  mov edx, SizeXXL
  .if sword ptr ax>=0
	add edx, SizeLarge-SizeXXL		; 280-360, 3 bytes
  .endif
  push CFM_SIZE
  push edx
  jmp CallSSF
proButton6 endp

proButton7 proc ; Red
  push CFM_COLOR
  push Font_RED
  jmp CallSSF
proButton7 endp

proButton8 proc ; Blue
  push CFM_COLOR
  push Font_BLUE
  jmp CallSSF
proButton8 endp

proButton9 proc ; Hilite
  push CFM_BACKCOLOR
  push BgYellow
;  jmp CallSSF no - fall thru
proButton9 endp

CallSSF: 
   call SetSelFormat	; invoke SetSelFormat, effect, mask
  ret

FindNext:
	or eax, -1
	jmp FindReplace

FindOnly:
	xor eax, eax		; flag it's find only, then fall through

FindReplace proc 		; Replace
LOCAL repl:DWORD, txrg:TEXTRANGE
  mov repl, eax
  if 0	; not here
	movi frs.lStructSize, sizeof FINDREPLACE - see above
  endif
  mov txrg.lpstrText, offset BufFind
  push esi
  lea esi, txrg
  sm hEdit, EM_EXGETSEL, 0, esi
  mov eax, txrg.chrg.cpMax
  sub eax, txrg.chrg.cpMin
  .if eax<20
	sm hEdit, EM_GETTEXTRANGE, 0, esi		; preload with current selection
	.if repl && repl!=-1
		mov eax, txrg.chrg.cpMin
		dec eax
		.if !Sign?
			mov txrg.chrg.cpMin, eax
			mov txrg.chrg.cpMax, eax
			sm hEdit, EM_EXSETSEL, 0, esi
		.endif
	.endif
  .endif
  pop esi
  push offset frs	; one longword
  cmp repl, -1
  je DoFR_F3		; fall through
  .if repl
	call ReplaceText	; expects one dword on stack
  .else
	call FindText	; expects one dword on stack
  .endif
  mov hFR, eax		; save the handle
@@:	ret		; return FindReplace
DoFR_F3:
  movi frs.Flags, FR_FINDNEXT
  invoke GetKeyState, VK_SHIFT		; GetKeyState returns a WORD (?)
  test ax, ax
  .if !Sign?		; sword ptr ax>=0
	or frs.Flags, FR_DOWN
  .endif
  pop eax					; correct stack and fall thru, passing pointer to frs
  call DoFR
  jmp @B
FindReplace endp

DoFR	proc
LOCAL ft:FINDTEXTEX
  push ebx
  push esi
  mov ebx, [eax.FINDREPLACE.Flags]
  .if ebx & FR_DIALOGTERM
	and hFR, 0							; flag handle no longer valid
	and [eax.FINDREPLACE.Flags], 0	; and this flag must be reset by hand!

  .elseif ebx & (FR_FINDNEXT or FR_REPLACE or FR_REPLACEALL)
  	m2m ft.lpstrText, [eax.FINDREPLACE.lpstrFindWhat]
  	sm hEdit, EM_EXGETSEL, 0, addr ft.chrg
  	or esi, -1		; default: from current sel to end of doc
  	.if ebx & (FR_REPLACE or FR_REPLACEALL)
	  	mov eax, ft.chrg.cpMax
		sub eax, ft.chrg.cpMin
		.if eax>20
	  		mov esi, ft.chrg.cpMax
	  	.endif
	.endif
  	.Repeat
	  	inc ft.chrg.cpMin
  		m2m ft.chrg.cpMax, esi
  		sm hEdit, EM_FINDTEXTEX, ebx, addr ft
  		.break .if signed eax<0
		sm hEdit,  EM_EXSETSEL, 0, addr ft.chrgText
		.if ebx & (FR_REPLACE or FR_REPLACEALL)
			sm hEdit,  EM_REPLACESEL, 1, offset BufRepl
		.endif
		invoke SetActiveWindow, hWin			; needed to show the selection
		sm hEdit,  EM_HIDESELECTION, 0, 0
  	.Until !(ebx & FR_REPLACEALL)
  .endif
  pop esi
  pop ebx
  ret
DoFR endp
	
MyFiles proc IsRead:DWORD
LOCAL ofn:OPENFILENAME
LOCAL hFile:DWORD, Read4:DWORD, dwBytesRead:DWORD
LOCAL editstream:EDITSTREAM
LOCAL LocBuf[MAX_PATH]:BYTE
  call ClearLocVars
  push esi
  mov esi, offset ComLineBuffer
  cmp IsRead, esi
  .if Zero?
  	dec eax
  .else
	lea esi, LocBuf
	movi ofn.lStructSize, sizeof OPENFILENAME
	m2m ofn.hWndOwner, hWin
	m2m ofn.hInstance, hInstance
	mov ofn.lpstrFilter, offset txFilter
	movi ofn.nMaxFile, MAX_PATH
	mov ofn.lpstrDefExt, chr$("rtf")		; an offset, mov is shorter
	; set the current folder:
	if useGMF
		invoke GMF, esi
	else
		invoke GetModuleFileName, 0, esi, MAX_PATH	; returns # of chars
	endif
@@:	dec eax
	cmp byte ptr [esi+eax],"\"
	jne @B
	mov byte ptr [esi+eax], ah	; ah is zero

@@:	mov ofn.lpstrInitialDir, esi
	mov esi, offset ComLineBuffer
	mov ofn.lpstrFile, esi	; mov shorter than m2m
	.if IsRead
		mov ofn.lpstrTitle, offset txtButton1	; chr$("Open")
		movi ofn.Flags, OFN_EXPLORER or OFN_LONGNAMES or OFN_PATHMUSTEXIST	; m2m longer
		invoke GetOpenFileName, addr ofn
	.elseif SaveAs
		invoke lstrcpy, esi, chr$("MyFile.rtf")
		mov ofn.lpstrTitle, chr$("Save my text:")
		movi ofn.Flags, OFN_EXPLORER or OFN_LONGNAMES or OFN_OVERWRITEPROMPT
		invoke GetSaveFileName, addr ofn
	.endif
	and SaveAs, 0
  .endif
  .if eax
	movi ecx, GENERIC_WRITE
  	movi edx, CREATE_ALWAYS
  	.if IsRead
  		add ecx, ecx	; aka movi ecx, GENERIC_READ - saves 4 bytes
		movi edx, OPEN_EXISTING
 	.endif
 	call MyFileOpen		; filename in esi
	; invoke CreateFile, esi, ecx, FILE_SHARE_READ, 0, edx, FILE_ATTRIBUTE_NORMAL, 0
	.if eax!=INVALID_HANDLE_VALUE
		mov hFile, eax
		mov editstream.dwCookie, eax
		push edi
		mov edi, offset WinTitleBuffer
		invoke lstrcpy, edi, offset AppName
		invoke lstrcat, edi, esi
		sm hWin, WM_SETTEXT, 0, edi
		pop edi
	   	movi ecx, EM_STREAMOUT
  		and StreamMode, 0
  		mov eax, [esi+len(esi)-4]
  		or eax, 20202000h
  		movi esi, SF_RTF
  		.if eax=="msa."					; ofn.nFilterIndex==2 unreliable
			add esi, SF_TEXT-SF_RTF	; same as movi esi, SF_TEXT
		.endif
		push ebx
		mov ebx, hEdit					; saves 12 bytes
		.if IsRead
			inc StreamMode
			invoke SetFocus, ebx			; give the focus to the edit window
			sm ebx, EM_SETTARGETDEVICE, 0, 0			
			invoke ReadFile, hFile, addr Read4, 4, ADDR dwBytesRead, 0
			invoke SetFilePointer, hFile, 0, 0, FILE_BEGIN
			mov eax, Read4
			or eax, 20200000h		; force lowercase for tr
			.if eax!="tr\{"
				mov esi, SF_TEXT	; rtf if you find the magic string
			.endif
		   	movi ecx, EM_STREAMIN
	  	.endif
		mov editstream.pfnCallback, StreamRTF		; 187/2718 for asc, 14.5*; 47/32 for WinInc
		sm ebx, ecx, esi, addr editstream
		invoke CloseHandle, hFile
		sm ebx, EM_SETMODIFY, 0, 0
		pop ebx
	.endif
  .endif
  pop esi
  ret
MyFiles endp

StreamRTF proc hFile:DWORD,pBuffer:DWORD, NumBytes:DWORD, pBytes:DWORD
  push 0
  push pBytes
  push NumBytes
  push pBuffer
  push hFile
  .if StreamMode
	call ReadFile
  .else
	mov edx, NumBytes
	mov eax, pBuffer
	lea ecx, [eax+edx-16]
	call WriteFile
  .endif
  xor eax, 1			; invert the logic of Read/WriteFile to indicate success or failure to RichEdit
  ret
StreamRTF endp

SetSelFormat proc CharFt:DWORD, CharFtMask:DWORD
  LOCAL charfmt:CHARFORMAT2
  call ClearLocVars
	movi charfmt.cbSize, sizeof CHARFORMAT2
	mrm charfmt.dwMask, CharFtMask
	mrm charfmt.crTextColor, CharFt
	sm hEdit, EM_GETCHARFORMAT, SCF_SELECTION, ADDR charfmt
	mov eax, CharFt

	.if CharFtMask==CFM_COLOR
	  .if charfmt.crTextColor==eax
		invoke GetSysColor, COLOR_WINDOWTEXT
	  .endif
	  mov charfmt.crTextColor, eax
	  movi eax, CFE_AUTOCOLOR
	  or charfmt.dwEffects, eax	; get rid of CFE_AUTOCOLOR
	  xor charfmt.dwEffects, eax

	.elseif CharFtMask==CFM_BACKCOLOR
	  .if charfmt.crBackColor==eax
		invoke GetSysColor, COLOR_WINDOW
	  .endif
	  mov charfmt.crBackColor, eax
	  movi eax, CFE_AUTOBACKCOLOR
	  or charfmt.dwEffects, eax	; get rid of CFE_AUTOBACKCOLOR
	  xor charfmt.dwEffects, eax

	.elseif CharFtMask==CFM_SIZE
	  or CharFtMask, CFM_FACE
	  mov ecx, offset MyFont	; sizing not possible with SysFont
	  .if charfmt.yHeight==eax
		mov eax, SizeNormal
		; mov ecx, offset SysFont
	  .endif
	  mov charfmt.yHeight, eax
	  invoke lstrcpy, addr charfmt.szFaceName, ecx	; max 32 chars
	.else
	  xor charfmt.dwEffects, eax	; sending twice toggles... in theory!
	.endif

	sm hEdit, EM_SETCHARFORMAT, SCF_SELECTION, ADDR charfmt
  ret
SetSelFormat endp

AssRun proc
LOCAL ft:FINDTEXT, IsCon:SDWORD, fvl
LOCAL txrg:TEXTRANGE, txRgOrg:TEXTRANGE, txRgAsm:TEXTRANGE
LOCAL editstream:EDITSTREAM
LOCAL LocBuf[1600]:BYTE
  call ClearLocVars
  push edi
  push ebx
  mov edi, hEdit
  xor ebx, ebx
  invoke SendMessage, edi, EM_EXGETSEL, ebx, addr txRgOrg
  invoke SendMessage, edi, EM_GETFIRSTVISIBLELINE, ebx, ebx
  invoke SendMessage, edi, EM_LINEINDEX, eax, ebx
  mov fvl, eax	; char index of first visible line
  dec ebx
  mov ft.chrg.cpMax, ebx	; -1, end of doc
  ; and ft.chrg.cpMin, 0	; 0, start of doc
  mov ft.lpstrText, chr$("pri","nt")
  call Susy
  add eax, eax
  add IsCon, eax
  mov ft.lpstrText, chr$("SendMes")
  call Susy
  sub IsCon, eax
  mov ft.lpstrText, chr$("WM_")
  call Susy
  sub IsCon, eax
  lea edi, LocBuf
  mrm ft.lpstrText, chr$("BATCH", "$")
  .Repeat
	sm hEdit, EM_FINDTEXT, FR_DOWN or FR_MATCHCASE, addr ft		; no FR_DOWN = FR_UP
	.if ebx	; ==1
		dec eax
		mov txRgAsm.chrg.cpMax, eax
		add eax, 8
		mov txrg.chrg.cpMin, eax
		mov ft.chrg.cpMin, eax
	.endif
	inc ebx
  .Until !Zero?		; two loops only
  mov ebx, offset txBatchDef		; default ?s TinyDef.bat if no batch$ pair found
  push esi
  test eax, eax
  jle @F
  add ebx, (offset txBatch-offset txBatchDef)
  mov txrg.chrg.cpMax, eax
  mov txrg.lpstrText, edi
  mov esi, ebx			; aka offset txBatch, for MyFiles
  lea ecx, txrg
  call WritePlain
@@:
  mrm txRgAsm.lpstrText, SelXXL$					; mrm 8, m2m 9 bytes
  mov esi, chr$("TinyTmp.asm")
  lea ecx, txRgAsm
  call WritePlain	; SelXXL$
  or esi, -1
  push ebx
  mov ebx, fvl
  .Repeat
	mov txRgOrg.chrg.cpMax, ebx
	xchg ebx, txRgOrg.chrg.cpMin	; put first visible line for first round
	invoke SendMessage, hEdit, EM_EXSETSEL, 0, addr txRgOrg
	inc esi
  .Until !Zero?
  pop ebx
  if useGMF
	invoke GMF, edi
  else
	invoke GetModuleFileName, 0, edi, MAX_PATH	; returns # of chars
  endif
  pop esi
  .Repeat
	.break .if byte ptr [edi+eax]=="\"
	dec eax
  .Until Sign?
  mov byte ptr [edi+eax+1], 0		; path to exe delimited with zero byte
  push ebx
  push edi
  mov ebx, lstrcat
  call ebx			; invoke lstrcat, edi, ebx
  push offset ComLineBuffer
  push edi
  call ebx			;  invoke lstrcat, edi, offset ComLineBuffer
  .if IsCon>=0
	push chr$(" SuSyCo")
	push edi
  	call ebx		; invoke lstrcat, edi, chr$(" SuSyCo")
  .endif
;  deb 4, "AssRun", $edi
  invoke WinExec, edi, SW_MAXIMIZE
  .if eax<=32
	MsgBox 0, edi, chr$("Could not launch:"), MB_OK
  .endif
  pop ebx
  pop edi
  ret

Susy:
  sm hEdit, EM_FINDTEXT, FR_DOWN or FR_MATCHCASE, addr ft	;edi
  test eax, eax
  .if !Sign?
	xor eax, eax
  .endif
  retN

WritePlain: ; fname in esi, sel in ecx	; EM_STREAMOUT
	push ecx
	movi ecx, GENERIC_WRITE
  	movi edx, CREATE_ALWAYS
	call MyFileOpen
	pop ecx		; sel
	.if eax!=INVALID_HANDLE_VALUE
		push eax	; handle
		mov editstream.dwCookie, eax
  		and StreamMode, 0
		mov editstream.pfnCallback, StreamRTF
		sm hEdit, EM_EXSETSEL, 0, ecx	; selection
		sm hEdit, EM_STREAMOUT, SF_TEXT or SFF_SELECTION, addr editstream
		call CloseHandle		; invoke CloseHandle, hFile
	.endif
	retn
AssRun endp

MyFileOpen proc
  invoke CreateFile, esi, ecx, FILE_SHARE_READ, 0, edx, FILE_ATTRIBUTE_NORMAL, 0
  .if eax==INVALID_HANDLE_VALUE
	MsgBox 0, esi, "Could not open this file:", MB_OK
  .endif
  retn
MyFileOpen endp

twips MACRO arg
  push arg
  call twipsP
  EXITM <eax>
ENDM
;	567 twips per cm: A4 = 21 X 29,7 cm
;	twips = 21*567 X 29.7X567 = 11907 * 16839,9

prtMargins	dd 700, 100, 900, 700
PrintRTF proc
LOCAL fSuccess:SDWORD
LOCAL OldSel:CHARRANGE
LOCAL psd:PAGESETUPDLG
LOCAL docInfo:DOCINFO
LOCAL fr:FORMATRANGE
hPrDC equ <ebx>
  call ClearLocVars				; clear all structure elements
  push edi
  push esi
  push ebx
  mov psd.lStructSize, sizeof PAGESETUPDLG
  mov esi, offset prtMargins
  lea edi, psd.rtMargin
  m2m ecx, 4
  push ecx
  push esi
  push edi
  mov psd.Flags, PSD_INHUNDREDTHSOFMILLIMETERS or PSD_DEFAULTMINMARGINS ;PSD_MARGINS
  rep movsd
  m2m psd.hwndOwner, hWin
  invoke PageSetupDlg, addr psd			; get a printer device context
  pop esi	; the unchanged order is
  pop edi	; intentional: we swap the pointers
  pop ecx
  .if !eax
	invoke CommDlgExtendedError
	test eax, eax
	jne PriError
  .else
	rep movsd
	invoke GlobalLock, psd.hDevMode
	push eax
;	mov [eax.DEVMODE.dmScale], 80	; optional scaling of output
	mov esi, rv(GlobalLock, psd.hDevNames)
	movzx eax, word ptr [esi.DEVNAMES.wOutputOffset]
	add eax, esi
	push eax
	movzx eax, word ptr [esi.DEVNAMES.wDeviceOffset]
	add eax, esi
	push eax
	movzx eax, word ptr [esi.DEVNAMES.wDriverOffset]
	add eax, esi
	push eax
	call CreateDC		; hPrDC=CreateDC(lpszDriver, lpszDevice, lpszOutput, pDeviceMode)
	xchg eax, hPrDC	; hPrDC = ebx!!
	invoke GlobalUnlock, psd.hDevNames
	invoke GlobalUnlock, psd.hDevMode
	ShowDevCaps = 0
	ife ShowDevCaps
		invoke GlobalFree, psd.hDevNames
		invoke GlobalFree, psd.hDevMode
	else
		pushad
	
		pushad
		mov esi, rv(GlobalLock, psd.hDevMode)	; we need to access the memory
		movzx eax, word ptr [esi.DEVMODE.dmOrientation]	; it's a "short" variable, but Masm needs "word"
		.if eax==DMORIENT_PORTRAIT
			MsgBox 0, "Portrait", "Hi", MB_OK
		.elseif eax==DMORIENT_LANDSCAPE
			MsgBox 0, "Landscape", "Hi", MB_OK
		.else
			MsgBox 0, "WTF", 0, MB_OK
		.endif
		invoke GlobalUnlock, psd.hDevMode		; unlock the mem
		invoke GlobalFree, psd.hDevMode		; and free it
		popad
	
		mov ebx, rv(GetDeviceCaps, hPrDC, PHYSICALWIDTH)	; yields 4960, a factor 2.x too small
		mov esi, rv(GetDeviceCaps, hPrDC, PHYSICALHEIGHT)	; yields 7015 - expected 16840 for A4
		mov edi, rv(GetDeviceCaps, hPrDC, PHYSICALOFFSETY)	; yields 100
		deb 1, "GdCaps", ebx, esi, edi
		popad
		jmp @F
	endif

	mov docInfo.cbSize, sizeof DOCINFO
	mov docInfo.lpszDocName, chr$("TinyRtf")
	invoke StartDoc, hPrDC, addr docInfo		; start a print job
	cmp eax, SP_ERROR
	je PriErrorDelDC
;	invoke SendMessage, hEdit, EM_SETTARGETDEVICE, hPrDC, cxPhys	; not needed
	mov fr.hdc, hPrDC
	mov fr.hdcTarget, hPrDC

	mov fr.rc.left, twips(psd.rtMargin.left)	; psd:PAGESETUPDLG
	neg eax
	mov fr.rc.right, eax
	add fr.rc.right, twips(psd.ptPaperSize.x)
	sub fr.rc.right, twips(psd.rtMargin.right)

	mov fr.rc.top, twips(psd.rtMargin.top)
	neg eax
	mov fr.rc.bottom, eax
	add fr.rc.bottom, twips(psd.ptPaperSize.y)
	sub fr.rc.bottom, twips(psd.rtMargin.bottom)

;	Get the current selection into a CHARRANGE
	invoke SendMessage, hEdit, EM_EXGETSEL, 0, addr fr.chrg
	mov eax, fr.chrg.cpMax
	mov edx, fr.chrg.cpMin
	mov OldSel.cpMax, eax
	mov OldSel.cpMin, edx
	sub eax, edx
	.if sdword ptr eax<=127		; User has not selected a lot of text, therefore print all pages
		invoke SendMessage, hEdit, EM_SETSEL, 0, -1
		invoke SendMessage, hEdit, EM_EXGETSEL, 0, addr fr.chrg	
	.endif

;	Use GDI to print successive pages
	.Repeat
		invoke StartPage, hPrDC
		mov fSuccess, eax
		.Break .if sdword ptr eax<=0
		push fr.rc.bottom
		invoke SendMessage, hEdit, EM_FORMATRANGE, 1, addr fr
		pop	fr.rc.bottom
;		 The rc.bottom member may be changed after the message is sent. If it is changed, it must indicate the
;		 largest rectangle that can fit within the bounds of the original rectangle and still contain the specified
;		 text without printing partial lines. It may be necessary to reset this value after each page is printed.
;		 These dimensions are given in TWIPS.  ([url=http://support.microsoft.com/kb/129860]MS Support[/url])
;		deb 1, "Loop", eax, fr.chrg.cpMin, fr.chrg.cpMax
		.Break .if eax<=fr.chrg.cpMin
		.Break .if eax>=fr.chrg.cpMax
		mov fr.chrg.cpMin, eax
		invoke EndPage, hPrDC
		mov fSuccess, eax
		dec eax
	.Until Sign?		; fSuccess<=0
	invoke SendMessage, hEdit, EM_FORMATRANGE, 0, 0	; free the cache, important
	push hPrDC		; aka ebx
	.if fSuccess>0
		call EndDoc
	.else
		call AbortDoc
	.endif
	invoke DeleteDC, hPrDC
	invoke SendMessage, hEdit, EM_EXSETSEL, 0, addr OldSel		; restore old selection
  .endif
@@:
  pop ebx
  pop esi
  pop edi
  ret
PriErrorDelDC:
 invoke DeleteDC, hPrDC
PriError:
  MsgBox 0, "Printing problem", 0, MB_OK
  jmp @B
PrintRTF endp
tw2cm	REAL4 0.567
twipsP proc
  ffree st(7)
  fld tw2cm
  pop edx
  fimul dword ptr [esp]
  fistp dword ptr [esp]
  pop eax
  jmp edx
twipsP endp
if useMb
  xx_endp:	; clv has align 4, distorts codesize
endif
ClearLocVars proc	; put "call ClearLocals" as first instruction after LOCALS - eax unchanged on exit
  push eax		; do not use with uses esi etc - push them manually behind the call!
  lea eax, [esp+8]		; pushed eax and ret address
  mov esp, ebp		; base page of calling procedure
  align 4		; 74 instead of 123 cycles on Celeron M, no effect on P4
@@:
  push 0		; 120 bytes: 196 cycles on P4
  cmp esp, eax		; rep stosd??
  ja @B
  sub esp, 8		; 19 bytes with align 4
  pop eax
  ret
ClearLocVars endp
end start

RichMasm options
OPT_Susy	Windows
OPT_Wait	0
OxPT_Icon	Smiley	; see \Masm32\RichMasm\Icons
OPT_DebugL	/merge:.text=.data
OPT_Tmp2Asm	1
OPT_Arg1	TinyDemo.rtf
OPT_Assembler	mlv615
